(*************************************************************************)
(*                                                                       *)
(*                                OCaPIC                                 *)
(*                                                                       *)
(*            Benoit Vaugon, Université Pierre et Marie Curie            *)
(*                                                                       *)
(*    Ce fichier est distribué sous les termes de la licence CeCILL-B    *)
(*    décrite dans le fichier ../../LICENCE.                             *)
(*                                                                       *)
(*************************************************************************)

exception Exn of string

type 'a channel

val open_tty : string -> 'a channel
(** [open_tty filename] opens the file [filename] (ex: /dev/tty0) and
create a connection to the PIC microcontroller.  *)

val open_prog : string -> 'a channel
(** Use open_prog instead of open_tty to simulate a serial
communication to the PIC. [open_prog cmnd] runs the command [cmnd] in
the shell /bin/sh.  [cmnd] is usually the pic executable. *)

val send : 'a channel -> 'a -> unit
(** Transmit an OCaml value to the PIC. *)
