(*************************************************************************)
(*                                                                       *)
(*                                OCaPIC                                 *)
(*                                                                       *)
(*            Benoit Vaugon, Université Pierre et Marie Curie            *)
(*                                                                       *)
(*    Ce fichier est distribué sous les termes de la licence CeCILL-B    *)
(*    décrite dans le fichier ../../../LICENCE.                          *)
(*                                                                       *)
(*************************************************************************)

type line_mode = One | Two
type display_mode = On | Off
type cursor_mode = Show | Hide | Blink
type bus_mode = Eight | Four
type direction = Left | Right
type font = F5x8 | F5x11

type display = {
  x : int;
  y : int;
  e : Simul.pin;
  rs : Simul.pin;
  rw : Simul.pin;
  bus : Simul.port;
  column_nb : int;
  line_nb : int;
  width : int;
  height : int;
  matrix : bool array array array array;
  cgram : bool array array array;
  ddram : char array;
  mutable cgram_addr : int;
  mutable ddram_addr : int;
  mutable line_mode : line_mode;
  mutable cursor_mode : cursor_mode;
  mutable entry_mode_incr : direction;
  mutable shift_display : bool;
  mutable display_mode : display_mode;
  mutable font : font;
  mutable bus_mode : bus_mode;
}
