(*************************************************************************)
(*                                                                       *)
(*                                OCaPIC                                 *)
(*                                                                       *)
(*            Benoit Vaugon, Université Pierre et Marie Curie            *)
(*                                                                       *)
(*    Ce fichier est distribué sous les termes de la licence CeCILL-B    *)
(*    décrite dans le fichier ../../LICENCE.                             *)
(*                                                                       *)
(*************************************************************************)

open Serial;;

type t = Clear | Moveto of int * int | Int of int | Text of string

let (chan : t channel) =
  open_prog "./usart 'ocapic_lcd_simulator 20x4 e=RD0 rs=RD2 rw=RD1 bus=PORTB'"
;;

let clear () = send chan Clear;;
let moveto l c = send chan (Moveto (l, c));;
let print_int i = send chan (Int i);;
let print_string s = send chan (Text s);;
