open Pic;;
open Lcd;;
open Serial;;

set_bit IRCF1;;
set_bit IRCF0;;
set_bit PLLEN;;

module Aff = Connect (
struct
  let bus_size = Eight
  let e  = LATD0
  let rs = LATD2
  let rw = LATD1
  let bus = PORTB
end
);;
open Aff;;

init ();;
config ~cursor:Underscore ();;

print_string "Hello";;
moveto 2 0;;

type t = Clear | Moveto of int * int | Int of int | Text of string

let (ic : t in_channel) = open_in 34;; (* 19200 bauds *)

while true do
  match receive ic with
    | Clear -> clear ()
    | Moveto (l, c) -> moveto l c
    | Int i -> print_int i
    | Text t -> print_string t
done
